# -*- coding: utf-8 -*-
"""
Created on Thu Jun  3 21:08:14 2021

@author: ECURBELO
"""
import pandas as pd
from ejemplo_paper import Ejemplo
from tabulate import tabulate
from scipy.stats import uniform as U
import numpy as np
import matplotlib.pyplot as plt
#%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

K = 8
xtrue = 2.5
sigmatrue = 4
sigma = 4
ex = Ejemplo( xtrue,sigmatrue,K,sigma)


# N = 10000
T = 100
initial_value_mu = 5
initial_value_sigma = 20
sigma_prop_init = 1

z_grid = 2.9662643134043414e-12

Ns = [100]

n_simulations = 5
sigmasss = np.array([11.41798803, 17.9848277 , 16.58574834, 15.07984048,  5.73436808])
all_sigmas = np.zeros((n_simulations,T+1,len(Ns)))

for i in range(n_simulations):
    
    initial_value_sigma = sigmasss[i]
        
    initial_value_mu = U(0,20).rvs()
    
    try:
        data = pd.read_csv("sim.csv")
    except:
        data = pd.DataFrame({"N":[],"error":[]})
    
    for ni,N in enumerate(Ns):
        
        
        
        ex = Ejemplo( xtrue,sigmatrue,K,sigma)
        
        data_N = list(data["N"])
        
        data_error = list(data["error"])
    
        ex.new_sampling(initial_value_mu, initial_value_sigma, sigma_prop_init, T, N)
    
        z = ex.Z_hat(100)
        
        relative_error = abs(z - z_grid)/z_grid
        
        data_N.append(N)
        
        data_error.append(relative_error)
        
        data = pd.DataFrame({"N":data_N,"error":data_error})
        
        all_sigmas[i,:,ni] = ex.sigmas_ml
        
        # data["N"] = data_N
        
        # data["error"] = data_error
        
        data.to_csv("sim.csv")
        
        # print(relative_error)
    print(f"Finish simulation {i}")
    
# %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
figure = plt.figure()
style = "*>spv1234"
ax = figure.add_subplot(111)
for i in range(n_simulations):
    _,len_,_ = all_sigmas.shape
    plt.plot(range(20),all_sigmas[i,:20,0],marker=style[i])  

ax.set_xlabel(r"t")
ax.set_ylabel(r"$\sigma_{ml}$")
ax.set_xticks(range(20))
    
# %%%%
ex.yk.std()
ex.sigmas_ml[-1]
